#define IN1f 4
#define IN2f 5
#define Vreff 3
#define LED 6

#define IN1s 13
#define IN2s 14
#define Vrefs 12
#define SS 21

long starttime;
int PV;
boolean dir;



void setup() {
  pinMode(IN1f, OUTPUT); // as IN1 of TB67H450FGN for FAN
  pinMode(IN2f, OUTPUT); // as IN2 of TB67H450FGN for FAN
  pinMode(Vreff, OUTPUT); // as Vref of TB67H450FGN for FAN
  pinMode(LED, OUTPUT); // as Indicater LED

//  Serial.begin(9600);
  analogWriteRange(255);
  analogWriteFreq(2000);

   analogWrite (IN1f, 180); //IN1         電源投入時のファン起動
   digitalWrite(IN2f, LOW); //IN2      
   digitalWrite(Vreff, HIGH); //Vref

   delay(80);

}


void loop() {
  int fanspeed = map(analogRead(A2),0,4095,65,255);

  if (fanspeed < 70){

   digitalWrite(LED,HIGH);
   
   int f = 0 ;
   f = f1Fluctuation(); 
   fanspeed = 255-f;
   
   analogWrite (IN1f, fanspeed); //IN1
   digitalWrite(IN2f, LOW);      //IN2
   digitalWrite(Vreff,HIGH);     //Vref

   delay(1500);
   
  }

  else{
   digitalWrite(LED,LOW);
   
   analogWrite (IN1f, fanspeed); //IN1   
   digitalWrite(IN2f, LOW);      //IN2
   digitalWrite(Vreff,HIGH);     //Vref
  
  }
//    Serial.println(fanspeed);
}


int f1Fluctuation() {

  float x = 0 ;

  if (x < 0.5) {
    x = x + 2 * x * x;
  }
  else {
    x = x - 2 * (1.0 - x) * (1.0 - x);
  }
  if (x < 0.005 || x > 0.995) {
    x = random(1, 99) / 100.0;
  }
  return (x * 255);
}



void setup1() {

  pinMode(IN1s, OUTPUT); // as IN1 of TB67H450FGN for Swing
  pinMode(IN2s, OUTPUT); // as IN2 of TB67H450FGN for Swing
  pinMode(Vrefs, OUTPUT); // as Vref of TB67H450FGN for Swing
  pinMode(LED,OUTPUT);
  pinMode(SS,OUTPUT); // as A of 74HC4052

  analogWriteRange(255);
  analogWriteFreq(2000);
  Serial.begin(9600);

  switch ( sensorread() ) {
    case 0:
      dir = CCW(180);
      break;

    case 1:
      dir = CCW(180);
      break;

    case 2:
      dir = CW(180);
      break;

    case 3:
      dir = CW(180);
      break;
  }
}

void loop1() {

  int VOL = analogRead(A0);
  VOL = map (VOL, 0, 4095, 0, 5200); //

  int CV = sensorread();
  long currenttime = millis();

  if (abs( PV - CV ) == 2) {  //中立点を検出した時の処理
    starttime = currenttime;
  }

  Serial.println(currenttime - starttime);


  // 左右スイング限界検出時の処理
  switch ( CV ) {
    case 0:               //現在位置：左端の処理
      swingstop();
      delay(500);
      
      dir = CCW(180);
      delay(1000);
      starttime = currenttime + 5200;
      break;

    case 2:               //現在位置：右端の処理
      swingstop();
      delay(500);
  
      
      dir = CW(180);
      delay(1000);
      starttime = currenttime + 5200;
      break;
  }


  if ( (currenttime - starttime) > VOL ) {
    if (dir == true) {
      
      swingstop();
      delay(500);
   
      
      if (VOL > 100) {
        dir = CCW(180);
        starttime = currenttime + 5200;
      }
      
      else {                  //スイング量指令値が極小のときはスイング停止　の処理
        if (CV == 1){
          dir = CW(0);
        }

        else {
          dir = CCW(0);
        }  
              
        starttime = 0;
        
      }
    }

    else {
      swingstop();
      delay(500);
      
      if (VOL > 100) {
        dir = CW(180);
        starttime = currenttime + 5200;
      }
      
      else {                  //スイング量指令値が極小のときはスイング停止　の処理
        if (CV == 1){
          dir = CW(0);
        }

        else{
          dir = CCW(0);
        }
        
        starttime = 0;
        
      }
    }
  }

  PV = CV;
  
}

int sensorread() {

  float SL = 0;
  float SH = 0;
  int LB;
  int HB;

  for (int i = 0; i < 10 ; i++) {
    digitalWrite(SS, LOW);    //Read LSB sensor
    SL = SL + analogRead(A1); 

    digitalWrite(SS,HIGH);    //Read MSB sensor
    SH = SH + analogRead(A1);
  }

  SL = SL / 10;
  SH = SH / 10;

//    Serial.print(SL);
//    Serial.print(" ");
//    Serial.println(SH);

  if (SL > 1000) {
    LB = 1;
  }

  else {
    LB = 0;
  }


  if (SH > 1000) {
    HB = 2;
  }

  else {
    HB = 0;
  }

  int result = LB + HB;

  return result;
}


boolean CW(int duty) {

  analogWrite (IN1s , duty); //IN1
  digitalWrite(IN2s, LOW);   //IN2
  digitalWrite(Vrefs, HIGH); //Vref

  return true;
}

boolean CCW(int duty) {

  digitalWrite(IN1s, LOW  ); //IN1
  analogWrite (IN2s, duty*104/100); //IN2
  digitalWrite(Vrefs, HIGH); //Vref

  return false;

}

void swingstop(){
  digitalWrite(IN1s, LOW); //IN1
  digitalWrite(IN2s, LOW); //IN2
}
